//
//  ITDataController.h
//  JiT
//
//  Created by Peter Kristensen on 18/09/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "JiTServerProtocol.h"
#import "JiTClientProtocol.h"

@class ITGroup, ITManualGroup, ITSmartGroup, ITTimer, ITProxy;

@interface ITDataController : NSObject <JiTClientProtocol> {

	id <JiTServerProtocol> server;
	NSConnection *connection;
    ITGroup *library;
    NSString *uuid;
	int versionFailCount; // cruel hack
}

+ (ITDataController *)sharedController;
- (NSArray *)groups;
- (ITTimer *)newTimer;
- (ITManualGroup *)newManualGroup;
- (ITSmartGroup *)newSmartGroup;

- (NSArray *)tagsForPredicate:(NSPredicate *)predicate;
- (ITGroup *)library;
- (void)deleteObject:(ITProxy *)obj;
- (void)deleteGroup:(ITGroup *)group;
- (void)cleanup;
- (NSString *)uuid;
- (id <JiTServerProtocol>)server;
- (BOOL)ping;
- (NSArray *)runningTimers;
- (BOOL)checkServerVersion;
- (NSArray *)exportTypes;
- (BOOL)exportToURL:(NSURL *)url withType:(NSString *)type;
- (ITProxy *)objectForURI:(NSURL *)uri;
- (void)backup:(NSURL *)url;
- (void)restore:(NSURL *)url;

@end
